<?php
/***********************************************************
	Filename: app/admin/models/elder.php
	Note	: 产品管理功能
	Version : 3.0
	Author  : qinggan
	Update  : 2010-12-19
***********************************************************/
class elder_m extends Model
{
	function __construct()
	{
		parent::Model();
	}
	function elder_m()
	{
		$this->__construct();
	}
	function get_one($id,$type="id")
	{
		if(!$id)
		{
			return false;
		}
		$sql = "SELECT e.*,s.shopname FROM ".$this->db->prefix."elder e LEFT JOIN ".$this->db->prefix."shop s ON(e.shopid=s.id) WHERE e.".$type."='".$id."'";
		$rs = $this->db->get_one($sql);
		if(!$rs)
		{
			return false;
		}
		return $rs;
	}
	function get_list($condition="",$pageid=0,$psize=20)
	{
		$sql = "SELECT e.*,s.shopname FROM ".$this->db->prefix."elder e LEFT JOIN ".$this->db->prefix."shop s ON(e.shopid=s.id) ";
		if($condition)
		{
			$sql .= " WHERE ".$condition;
		}
		$offset = $pageid>0 ? ($pageid-1) * $psize : 0;
		$sql .= " ORDER BY e.shopid ASC,convert(e.lifestatus using gb2312) ASC,e.bed_number+0 ASC,e.id DESC LIMIT ".$offset.",".$psize;
		return $this->db->get_all($sql);
	}
	function get_count($condition="")
	{
		$sql = "SELECT count(e.id) FROM ".$this->db->prefix."elder e LEFT JOIN ".$this->db->prefix."shop s ON(e.shopid=s.id) ";
		if($condition)
		{
			$sql .= " WHERE ".$condition;
		}
		return $this->db->count($sql);
	}
	//存储数据
	function save($data,$id=0)
	{
		if($id)
		{
			$this->db->update_array($data,"elder",array("id"=>$id));
			return true;
		}
		else
		{
			$insert_id = $this->db->insert_array($data,"elder");
			return $insert_id;
		}
	}
	function del($id)
	{
		$sql = "DELETE FROM ".$this->db->prefix."elder WHERE id='".$id."'";
		return $this->db->query($sql);
	}
	//检测编号
	function chk_num($num,$shopid,$id=0)
	{
		$sql = "SELECT * FROM ".$this->db->prefix."elder WHERE num='".$num."' AND shopid='".$shopid."'";
		if($id)
		{
			$sql .= " AND id !='".$id."' ";
		}
		return $this->db->get_one($sql);
	}

	//检测编号
	function chk_num2($num,$shopid,$id=0)
	{
		$sql = "SELECT * FROM ".$this->db->prefix."elder WHERE bed_number='".$num."' AND shopid='".$shopid."' AND lifestatus='生存'";
		if($id)
		{
			$sql .= " AND id !='".$id."' ";
		}
		return $this->db->get_one($sql);
	}
	
	//取得最大ID
	function get_next_id()
	{
		$sql = "SHOW TABLE STATUS WHERE Name='".$this->db->prefix."elder'";
		$rs = $this->db->get_one($sql);
		return $rs["Auto_increment"];
	}
	function expense_all($eid,$keyid="proid")
	{
		if(!$eid)
		{
			return false;
		}
		$sql = "SELECT e.*,p.title,p.price FROM ".$this->db->prefix."elder_expense e LEFT JOIN ".$this->db->prefix."products p ON(e.proid=p.id) WHERE e.eid='".$eid."' AND e.pronum>'0'";
		$tmplist = $this->db->get_all($sql,$keyid);
	}
	function expense_del($proid,$eid)
	{
		if(!$proid || !$eid)
		{
			return false;
		}
		$sql = "DELETE FROM ".$this->db->prefix."elder_expense WHERE eid='".$eid."' AND proid='".$proid."'";
		return $this->db->query($sql);
	}
	function expense_save($proid,$eid,$pronum)
	{
		$sql = "REPLACE INTO ".$this->db->prefix."elder_expense(proid,eid,pronum) VALUES('".$proid."','".$eid."','".$pronum."')";
		//echo $sql."<br />";
		return $this->db->query($sql);
	}
}