<?php

#=====================================================================

#	Filename: app/admin/control/ctrl.php

#	Note	: 模块控制中心

#	Version : 3.0

#	Author  : qinggan

#	Update  : 2009-11-4

#=====================================================================

class ctrl_c extends Control

{

	var $module_sign = "module";

	function __construct()

	{

		parent::Control();

		$this->load_model("module");//读取模块列表

	}



	function ctrl_c()

	{

		$this->__construct();

	}



	function gset_f()

	{

		sys_popedom($this->module_sign.":group","tpl");

		$id = $this->trans_lib->int("id");

		if($id)

		{

			$this->tpl->assign("id",$id);

			$rs = $this->module_m->group_one($id);

			$this->tpl->assign("rs",$rs);

		}

		$this->tpl->display("ctrl/gset.html");

	}



	function gsetok_f()

	{

		sys_popedom($this->module_sign.":group","tpl");

		$id = $this->trans_lib->int("id");

		$array["title"] = $this->trans_lib->safe("title");

		$array["status"] = $this->trans_lib->int("status");

		$array["taxis"] = $this->trans_lib->int("taxis");

		$array["js_function"] = $this->trans_lib->safe("js_function");

		if(!$id)

		{

			$array["langid"] = $_SESSION["sys_lang_id"];

		}

		$this->module_m->group_save($array,$id);

		error("模块组编辑/添加成功！",$this->url("ctrl"));

	}



	function gdel_f()

	{

		sys_popedom($this->module_sign.":group","ajax");

		$id = $this->trans_lib->int("id");

		if(!$id)

		{

			exit("error:没有指定组ID");

		}

		$condition = array();

		$condition["groupid"] = $id;

		$condition["langid"] = $_SESSION["sys_lang_id"];

		$rslist = $this->module_m->get_list(0,$condition);

		if($rslist)

		{

			exit("error:模块组中有相应的模块信息，请先转移或删除！");

		}

		$this->module_m->group_del($id);

		exit("ok");

	}



	function index_f()

	{

		sys_popedom($this->module_sign.":list","tpl");

		$groupid = $this->trans_lib->int("groupid");

		$condition = array();

		if($groupid)

		{

			$condition["groupid"] = $groupid;

			$this->tpl->assign("groupid",$groupid);

		}

		$condition["langid"] = $_SESSION["sys_lang_id"];

		$pageid = $this->trans_lib->int(SYS_PAGEID);

		$rslist = $this->module_m->get_list($pageid,$condition);

		$this->tpl->assign("rslist",$rslist);

		$total = $this->module_m->get_count();//读取模块总数

		$page_url = $this->url("ctrl,index","groupid=".$groupid);

		$pagelist = $this->page_lib->page($page_url,$total);

		if($pagelist)

		{

			$this->tpl->assign("pagelist",$pagelist);

		}

		//获取所有模块

		$grouplist = $this->module_m->all_module_group();

		$this->tpl->assign("grouplist",$grouplist);

		$this->tpl->display("ctrl/list.html");

	}



	//更改状态

	function status_f()

	{

		$id = $this->trans_lib->int("id");

		if(!$id)

		{

			exit("error: 操作非法，没有指定ID");

		}

		sys_popedom($this->module_sign.":check","ajax");

		$rs = $this->module_m->get_one($id);

		if($rs["if_system"])

		{

			exit("error: 核心模块不允许此操作");

		}

		$this->module_m->status($id);

		exit("ok");

	}



	//删除模块

	function del_f()

	{

		$id = $this->trans_lib->int("id");

		if(!$id)

		{

			exit("error: 操作非法，没有指定ID");

		}

		sys_popedom($this->module_sign.":delete","ajax");

		//判断是否有内容

		$rs = $this->module_m->if_list($id);

		if($rs)

		{

			exit("error: 该模块已经有内容了，不允许删除");

		}

		//判断是否是核心模块，核心模块不允许删除

		$if_system = $this->module_m->if_system_module($id);

		if($if_system)

		{

			exit("error: 系统模块不允许删除");

		}

		//删除模块操作

		$this->module_m->del($id);

		exit("ok");

	}



	//编辑或添加模块

	function set_f()

	{

		$id = $this->trans_lib->int("id");

		$inc_module = array();

		if($id)

		{

			sys_popedom($this->module_sign.":modify","tpl");

			//[读取数据]

			$rs = $this->module_m->get_one($id);

			if($rs["inc_module"])

			{

				$inc_module = explode(",",$rs["inc_module"]);

			}

		}

		else

		{

			sys_popedom($this->module_sign.":add","tpl");

			$rs["popedom"] = array();

		}

		$this->tpl->assign("inc_module",$inc_module);

		$this->tpl->assign("rs",$rs);

		//读取使用权限的字段

		$this->load_model("identifier");

		$popedom_list = $this->identifier_m->get_sign("popedom");

		$this->tpl->assign("popedom_list",$popedom_list);

		//取得模块组

		$group_list = $this->module_m->top();

		$this->tpl->assign("group_list",$group_list);



		$this->tpl->display("ctrl/set.html");

	}



	//存储信息

	function setok_f()

	{

		$id = $this->trans_lib->int("id");

		$array = array();

		$array["title"] = $this->trans_lib->safe("title");//模块名

		if(!$array["title"])

		{

			error("标题不允许为空",site_url("ctrl,set","id=".$id));

		}

		$array["group_id"] = $this->trans_lib->int("group_id");//组ID

		$array["note"] = $this->trans_lib->safe("note");//备注

		if(!$id)

		{

			sys_popedom($this->module_sign.":add","tpl");

			//在添加操作时核心参数的配置

			//判断标识符是否使用了

			$array["langid"] = $_SESSION["sys_lang_id"];//读取ID

			$array["identifier"] = $this->trans_lib->safe("identifier");//标识签，必须是唯一的

			if(!$array["identifier"])

			{

				error("标识串不允许为空",site_url("ctrl,set","id=".$id));

			}

			$chk_msg = $this->chk_identifier_f($array["identifier"]);

			if(!$chk_msg)

			{

				error("标识符不符合系统要求",site_url("ctrl,set","id=".$id));

			}

		}

		else

		{

			sys_popedom($this->module_sign.":modify","tpl");

		}

		//分析控制层是否符合系统要求

		$array["ctrl_init"] = $this->trans_lib->safe("ctrl_init");

		if(!$array["ctrl_init"])

		{

			error("控制层配置为空，请检查",site_url("ctrl,set","id=".$id));

		}

		if(!ereg("[a-z][a-z0-9\_]+",$array["ctrl_init"]))

		{

			error("控制层仅限字母，数字及下划线且要求必须是字母开头",site_url("ctrl,set","id=".$id));

		}

		if(!file_exists(APP."control/".$array["ctrl_init"].".php"))

		{

			error("没有找到控制层文件:(",site_url("ctrl,set","id=".$id));

		}

		$array["taxis"] = $this->trans_lib->int("taxis");//排序

		//读取权限配置信息

		$popedom = $this->trans_lib->safe("popedom");

		$array["popedom"] = sys_id_string($popedom);//收集权限

		$this->module_m->save($array,$id);

		Error("模块信息配置成功",site_url("ctrl"));

	}



	function chk_identifier_f($val="")

	{

		$exit = $val ? false : true;

		if(!$val)

		{

			$val = $this->trans_lib->safe("identifier");

		}

		if(!$val)

		{

			if($exit)

			{

				exit("error: 标识串为空");

			}

			else

			{

				return false;

			}

		}

		//判断这个标识符是否有被使用

		$if_used = $this->module_m->chk_identifier($val);

		if($if_used)

		{

			if($exit)

			{

				exit("error: 标识串已经被使用");

			}

			else

			{

				return false;

			}

		}

		//判断标识串是否符合要求

		if(!ereg("[a-z][a-z0-9\_]+",$val))

		{

			if($exit)

			{

				exit("error: 标识串仅限小写英文字母，数字及下划线，且第一位必须是字母");

			}

			else

			{

				return false;

			}

		}

		if($exit)

		{

			exit("ok");

		}

		else

		{

			return true;

		}

	}



	//更改状态

	function fields_status_f()

	{

		$id = $this->trans_lib->int("id");

		if(!$id)

		{

			exit("error: 操作非法，没有指定ID");

		}

		sys_popedom($this->module_sign.":check","ajax");

		$this->module_m->fields_status($id);

		exit("ok");

	}

}

?>