<?php
/***********************************************************
	Filename: app/admin/control/plexpense.php
	Note	: 批量生成表单
	Version : 3.0
	Author  : qinggan
	Update  : 2011-01-19
***********************************************************/
class plexpense_c extends Control
{
	function __construct()
	{
		parent::Control();
		$this->load_model("expense");
		$this->load_model("elder");
		$this->load_model("products");
		$this->load_model("shop");
		$this->load_model("admin");
		$this->load_model("day");
	}

	function plexpense_c()
	{
		$this->__construct();
	}


	function index_f()
	{
		sys_popedom("plexpense:setting","tpl");//添加权限
		$admin_rs = $this->admin_m->get_one($_SESSION["admin_id"]);
		$this->tpl->assign("admin_rs",$admin_rs);
		$shoplist = $this->shop_m->get_all("status='1'");//取得所有分类
		if(!$admin_rs["if_system"])
		{
			$tmp_shoplist = array();
			$tmp_shopid = array();
			foreach($shoplist AS $key=>$value)
			{
				if($value["admin_name"] && in_array($_SESSION["admin_name"],sys_id_list($value["admin_name"])))
				{
					$tmp_shoplist[] = $value;
					$tmp_shopid[] = $value["id"];
				}
			}
			if(count($tmp_shoplist)<1)
			{
				error("该管理员没有相关分院权限");
			}
			$shoplist = $tmp_shoplist;
		}
		$this->tpl->assign("shoplist",$shoplist);

		//
		$rs = array();
		$exp_mth_no = $this->trans_lib->safe("exp_mth_no");
		$ret_mth_no = $this->trans_lib->safe("ret_mth_no");
		$rs["exp_mth_no"] = $exp_mth_no ? $exp_mth_no : date("Y/m",$this->system_time);
		$rs["ret_mth_no"] = $ret_mth_no ? $ret_mth_no : date("Y/m",$this->system_time+24*60*60*30);
		$this->tpl->assign("rs",$rs);
		$shopid = $this->trans_lib->int("shopid");
		$this->tpl->assign("shopid",$shopid);
		$condition = "1=1";
		if($rs["exp_mth_no"])
		{
			$condition .= " AND h.exp_month='".$rs["exp_mth_no"]."'";
		}
		if($rs["ret_mth_no"])
		{
			$condition .= " AND h.ret_month='".$rs["ret_mth_no"]."'";
		}
		//获取历史记录
		$rslist = $this->expense_m->history_30($condition);
		$this->tpl->assign("rslist",$rslist);
		$this->tpl->display("expense/pl_expense.html");
	}

	function pl_f()
	{
		$shopid = $this->trans_lib->int("shopid");
		if(!$shopid)
		{
			error("请选择分院！",$this->url("plexpense"));
		}
		$exp_mth_no = $this->trans_lib->safe("exp_mth_no");
		$ret_mth_no = $this->trans_lib->safe("ret_mth_no");
		if(!$exp_mth_no || !$ret_mth_no)
		{
			error("数据不完整！",$this->url("plexpense"));
		}
		$condition = "e.shopid='".$shopid."' AND p.exp_mth_no='".$exp_mth_no."' AND p.ret_mth_no='".$ret_mth_no."'";
		$count = $this->expense_m->get_count($condition);
		if($count>0)
		{
			error("已存在部分数据，不能执行下一步，请返回检查！",$this->url("plexpense"));
		}
		//存储记录
		$array = array();
		$array["admin_id"] = $_SESSION["admin_id"];
		$array["exp_month"] = $exp_mth_no;
		$array["ret_month"] = $ret_mth_no;
		$array["shopid"] = $shopid;
		$array["postdate"] = $this->system_time;
		$this->expense_m->save_history($array);
		sys_header($this->url("plexpense,plok","shopid=".$shopid."&exp_mth_no=".rawurlencode($exp_mth_no)."&ret_mth_no=".rawurlencode($ret_mth_no)));
	}

	function plok_f()
	{
		$shopid = $this->trans_lib->int("shopid");
		if(!$shopid)
		{
			error("请选择分院！",$this->url("plexpense"));
		}
		$exp_mth_no = $this->trans_lib->safe("exp_mth_no");
		$ret_mth_no = $this->trans_lib->safe("ret_mth_no");
		if(!$exp_mth_no || !$ret_mth_no)
		{
			error("数据不完整！",$this->url("plexpense"));
		}
		$psize = 10;//每次生成10个
		$condition = "e.shopid='".$shopid."' AND e.lifestatus='生存'";
		//$total = $this->elder_m->get_count($condition);
		$pageid = $this->trans_lib->int(SYS_PAGEID);
		if($pageid<1) $pageid = 1;
		$rslist = $this->elder_m->get_list($condition,$pageid,$psize);//取得产品列表
		if(!$rslist)
		{
			error("数据已创建完成，请到列表中检查！",$this->url("plexpense"));
		}
		//批量生成新的数据
		$numlist = array();
		foreach($rslist AS $key=>$value)
		{
			$chk_exists = $this->expense_m->chk_exists($value["id"],$exp_mth_no,$ret_mth_no);
			if($chk_exists)
			{
				continue;
			}
			$array = array();
			$array["ret_charge"] = $value["rent"];
			$array["exp_mth_no"] = $exp_mth_no;
			$array["ret_mth_no"] = $ret_mth_no;
			$array["elder_id"] = $value["id"];
			$array["addtime"] = $this->system_time;
			$array["status"] = 0;
			$array["admin_id"] = $_SESSION["admin_id"];
			$array["printcount"] = 0;
			$array["exp_charge"] = 0;
			$array["exp_diapers"] = $value["diapers"];
			$array["fixed_charges"] = $value["fixed_charges"];
			$sublist = $this->day_m->expense_all($value["id"],'proid',$exp_mth_no);
			if(!$sublist){
				$sublist = $this->elder_m->expense_all($value["id"]);
			}
			if($sublist){
				foreach($sublist AS $k=>$v){
					$array["exp_charge"] += $v["price"] * $v["pronum"];
				}
			}
			//存储数据
			$insert_id = $this->expense_m->save($array);
			if(!$insert_id){
				continue;
			}
			$numlist[] = $value["num"];
			if(!$sublist)
			{
				continue;
			}
			foreach($sublist AS $k=>$v)
			{
				$tmp_array = array();
				$tmp_array["pid"] = $v["proid"];
				$tmp_array["title"] = $v["title"];
				$tmp_array["qty"] = $v["pronum"];
				$tmp_array["eid"] = $insert_id;
				$tmp_array["price"] = $v["price"];
				$this->expense_m->save_exp($tmp_array);
			}
		}
		$lasturl = $this->url("plexpense,plok","shopid=".$shopid."&exp_mth_no=".rawurlencode($exp_mth_no)."&ret_mth_no=".rawurlencode($ret_mth_no)."&".SYS_PAGEID."=".($pageid+1));
		error("正在生成中，当前进度：<span class='red'>".sys_id_string($numlist)."</span>…",$lasturl);
	}
}
?>